[Leetcode 198]强盗偷家 House Robber

 

【题目】

 

此系列有三题,都是强盗偷家不能偷相邻邻居,否则会被发现。问最多能偷多少钱

You are a professional robber planning to rob houses along a street. Each house has a certain amount of money stashed, the only constraint stopping you from robbing each of them is that adjacent houses have security systems connected and it will automatically contact the police if two adjacent houses were broken into on the same night.

Given an integer array nums representing the amount of money of each house, return the maximum amount of money you can rob tonight without alerting the police.

 

Example 1:

Input: nums = [1,2,3,1]
Output: 4
Explanation: Rob house 1 (money = 1) and then rob house 3 (money = 3).
Total amount you can rob = 1 + 3 = 4.

Example 2:

Input: nums = [2,7,9,3,1]
Output: 12
Explanation: Rob house 1 (money = 2), rob house 3 (money = 9) and rob house 5 (money = 1).
Total amount you can rob = 2 + 9 + 1 = 12.

 

【思路】

  • 动态规划,设有1 2 3 4 5户人家
  • 要么从1要么从2开始偷(不可能从3开始偷,因为1号不偷白不偷)
  • 因此 第i家最大值=MAX((第i家的钱+ i-2家最大值),i-1家最大值)

【代码】

class Solution {
    public int rob(int[] nums) {
        int len=nums.length;
        if(len<2)
            return nums[0];
        int[] dp=new int[len];
        dp[0]=nums[0];
        dp[1]=Math.max(dp[0],nums[1]);
        for(int i=2;i<len;i++){
            dp[i]=Math.max(dp[i-1],dp[i-2]+nums[i]);
        }
        return dp[len-1];
    }
}

 

上一篇:成员函数做友元函数


下一篇:【List转Map操作】Collectors.toMap语法分享(案例实践)